/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components;

/**
 *
 * @author nico3000
 */
public class Button extends Component {
    private String text;
    private boolean focused = false;
    private boolean hovered = false;
    private boolean pressed = false;

    public Button(String text) {
        this.text = text;
    }

    @Override
    public boolean onCursorEntered(int x, int y) {
        this.hovered = true;
        this.repaint();
        return true;
    }

    @Override
    public void onCursorMoved(int posX, int posY, int dx, int dy) {
        
    }

    @Override
    public void onCursorLeft() {
        this.hovered = false;
        this.repaint();
    }

    @Override
    public boolean onFocusGained() {
        this.focused = true;
        this.repaint();
        return true;
    }

    @Override
    public boolean onDragged(int button, int x, int y, int dx, int dy) {
        return false;
    }

    @Override
    public void onFocusLost() {
        this.focused = false;
        this.repaint();
    }

    @Override
    public void onUpdate(long deltaMillis) {
    }

    @Override
    public boolean onButtonDown(int button, int x, int y) {
        if(button == 0) {
            this.pressed = true;
            this.repaint();
            return true;
        } else {
            return false;
        }
    }

    @Override
    public boolean onButtonUp(int button, int x, int y, boolean clicked) {
        if(button == 0) {
            this.pressed = false;
            if(this.hovered) {
                this.fireAction();
            }
            this.repaint();
            return true;
        } else {
            return false;
        }
    }    
    
    @Override
    protected void repaint() {
        if(this.text.startsWith("res:")) {
            this.setTexture(this.getGui().getDrawer().createImageButton(this.text.substring(4), this.getWidth(), this.getHeight(), this.focused, this.hovered, this.pressed & this.hovered));
        } else {
            this.setTexture(this.getGui().getDrawer().createButton(this.text, this.getWidth(), this.getHeight(), this.focused, this.hovered, this.hovered && this.pressed & this.hovered));
        }        
    }

    @Override
    public boolean onKeyDown(int key, char c) {
        return false;
    }

    @Override
    public boolean onKeyUp(int key) {
        return false;
    }
}
