/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components;

import graphics.texture.TextureLoader;
import main.GameApp;
import util.MathUtil;

/**
 *
 * @author nico3000
 */
public class Cursor extends Component {
    private int pointerOffsetX = 0;
    private int pointerOffsetY = 0;

    public Cursor() {
        this.setLocalZOrder(Integer.MAX_VALUE);
        this.setSize(16, 16);
        this.pointerOffsetX = 1;
        this.pointerOffsetY = 14;
        this.setTexture(TextureLoader.getTexture("Textures/Cursor.png"));
    }

    public int getPointerX() {
        return this.getGlobalX() + this.pointerOffsetX;
    }

    public int getPointerY() {
        return this.getGlobalY() + this.pointerOffsetY;
    }
    
    public void setPointerPos(int x, int y) {
        x = MathUtil.clamp(x, 0, GameApp.getGraphicsLayer().getWidth()) - this.pointerOffsetX;
        y = MathUtil.clamp(y, 0, GameApp.getGraphicsLayer().getHeight()) - this.pointerOffsetY;
        this.setAbsolutePosition(x, y);
    }

    @Override
    public void onUpdate(long deltaMillis) {
    }

    @Override
    public boolean onCursorEntered(int x, int y) {
        return false;
    }

    @Override
    public boolean onFocusGained() {
        return false;
    }

    @Override
    public boolean onDragged(int button, int x, int y, int dx, int dy) {
        return false;
    }

    @Override
    public void onFocusLost() {
        // nothing to do
    }

    @Override
    public void onCursorLeft() {
        // nothing to do
    }

    @Override
    public void onCursorMoved(int posX, int posY, int dx, int dy) {
        // nothing to do
    }

    @Override
    public boolean onButtonDown(int button, int x, int y) {
        return false;
    }

    @Override
    public boolean onButtonUp(int button, int x, int y, boolean clicked) {
        return false;
    }

    @Override
    public boolean onKeyDown(int key, char c) {
        return false;
    }

    @Override
    public boolean onKeyUp(int key) {
        return false;
    }

    @Override
    protected void repaint() {
        // nothing to do
    }
    
}
