/*
 * Copyright (C) 2013 nico3000 - All Rights Reserved
 */
package test;

import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author nico3000
 */
public class DistanceTextures {
    public static void main(String argv[]) {
        int width = 64;
        int height = 64;
        DataOutputStream dos = null;
        try {
            dos = new DataOutputStream(new FileOutputStream("D:\\Dropbox\\Dropbox\\Aufbau interaktiver 3D-Engines\\resources\\textures\\dst\\test.dst"));
            dos.writeInt(width);
            dos.writeInt(height);
            for(int y=0; y < height; ++y) {
                for(int x=0; x < width; ++x) {
                    float posX = 2.0f * (float)x / (float)(width - 1) - 1.0f;
                    float posY = 2.0f * (float)y / (float)(height - 1) - 1.0f;
                    float len = (float)Math.sqrt(posX * posX + posY * posY);
                    if(len < 0.5f) {
                        dos.writeFloat(0.5f - len);
                    } else if(len < 0.7f) {
                        dos.writeFloat(0.0f);
                    } else {
                        dos.writeFloat(len - 0.7f);
                    }
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(DistanceTextures.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            if(dos != null) {
                try {
                    dos.close();
                } catch (IOException ex) {
                    Logger.getLogger(DistanceTextures.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
}
