/*
 * Copyright (C) 2013 nico3000 - All Rights Reserved
 */
package util;

import java.awt.image.BufferedImage;
import java.nio.FloatBuffer;
import org.lwjgl.BufferUtils;

/**
 *
 * @author nico3000
 */
public class ImageUtil {    
    public static FloatBuffer bufferedImage2floatBuffer(BufferedImage image) {
        FloatBuffer buffer = BufferUtils.createFloatBuffer(image.getWidth() * image.getHeight() * image.getColorModel().getNumComponents());
        for(int y=0; y < image.getHeight(); ++y) {
            for(int x=0; x < image.getWidth(); ++x) {
                for(int c=0; c < image.getColorModel().getNumComponents(); ++c) {
                    buffer.put(image.getRaster().getSampleFloat(x, y, c) / 255.0f);
                }
            }
        }
        buffer.position(0);
        return buffer;
    }
}
